#include "header.h"


/*------------------------------------------------------------------------------------------------*/
/*             Fonction permettant de dtecter les variables locales d'un type choisi             */
/*------------------------------------------------------------------------------------------------*/

int strDetectVar(int nbLignes, char ScNom[50], char varChar[6]) {

FILE *fScript, *fLog;
char c, cInt[7], nomVar[50], nomVar2[50];
int k, l, test, m;
INFO inf;

fScript = fopen(ScNom, "rt");
if ( fScript == NULL ) {
   return 20;
}

fLog = fopen("InfTempTES3", "ab");
if ( fLog == NULL ) {
   return 21;
}

for ( k = 0; k < (nbLignes+1); k++ ) { // On parcourt l'ensemble des lignes
    c = getc(fScript); // Acquisition caractre par caractre
    while ( ( typeChar(c) == 1 ) && ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) c = getc(fScript); // Tant que c'est un espace, on continue
    test = 1;
    if ( isalpha(c) == 1 ) c = tolower(c); // Mise en minuscule de la lettre pour les tests
    if ( c != varChar[0] ) test = 0; // Comparaison avec le type de variables recherch
    else {
         l = 1;
         while ( ( l < strlen(varChar) ) && ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) {
               c = getc(fScript);
               if ( isalpha(c) == 1 ) c = tolower(c);
               if ( c != varChar[l] ) test = 0;
               l++;
         }
         l = 0;
         if ( ( test == 1 ) && ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) { // Si on a trouv la variable du bon type, on cherche son petit nom ^^
            c = getc(fScript);
            while ( c == ' ' ) c = getc(fScript);
            while ( ( typeChar(c) == 2 ) || ( ( isdigit(c) != 0 ) && ( l > 0 ) ) ) {
                  nomVar[l] = c;
                  c = getc(fScript);
                  l++;
            }
            if ( strlen(nomVar) != 0 ) { // On code le type cherch en entier
                 if ( strncmp(varChar, "short", 5) == 0 ) {
                      inf.typeInf = 0;
                 }
                 if ( strncmp(varChar, "float", 5) == 0 ) {
                      inf.typeInf = 1;
                 }
                 if ( strncmp(varChar, "long", 4) == 0 ) {
                      inf.typeInf = 2;
                 }
                 if ( l < 50 ) nomVar[l] = '\0';
                 strcpy(inf.Nom, nomVar);
                 triInfo(inf); // On mmorise l'information de l'existence de cette variable
            }
         }
    }
    while ( ( c != '\n' ) && ( c != '\r' ) && ( c != EOF ) ) c = getc(fScript); // ... et on va  la fin de la ligne.
}

fclose(fScript);
fclose(fLog);
return 0;

}
