#include "header.h"



/*------------------------------------------------------------------------------*/
/*           Fonction principale de dtection des erreurs de syntaxe            */
/*------------------------------------------------------------------------------*/

void syntaxe(int nbLignes, char ScNom[50], int trib, int blood) {

FILE *fScript, *fLog;
char c, cInt[7], ligne[5000];
int k, l, m, test, testEnd, cEnd, ligneType[5000], ok, ligneTraitee, check, var, varType, nomScript, varScn, declarations, varDcl, BlocBegin[5000], ligneBegin[5000], ligneEnd[5000], ligneEndif[5000], ligneEndwhile[5000];
ERREUR err;


fScript = fopen(ScNom, "rt");
if ( fScript == NULL ) {
   printf("Impossible d'ouvrir le fichier \"%s\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
   system("PAUSE");
   exit(1);
}

/* Dtection des blocs Begin/End */
strDetectTest(ligneBegin, nbLignes, ScNom, "begin");
strDetectTest(ligneEnd, nbLignes, ScNom, "end");
strDetectTest(ligneEndif, nbLignes, ScNom, "endif");
strDetectTest(ligneEndwhile, nbLignes, ScNom, "endwhile");
for ( k = 0; k < nbLignes; k++ ) {
    if ( ligneEnd[k] != 0 ) {
         if ( ligneEndif[k] != 0 ) ligneEnd[k] = 0;
         if ( ligneEndwhile[k] != 0 ) ligneEnd[k] = 0;
    }
}

var = 0;
for ( k = 0; k < nbLignes; k++ ) {
    BlocBegin[k] = var;
    if ( ligneBegin[k] == 1 ) {
         var = 1;
         BlocBegin[k] = 1;
    }
    else {
         if ( ( var == 1 ) && ( ligneEnd[k] == 1 ) ) var = 0;
    }
}

nomScript = 0;
varScn = 0;
declarations = 0;
varDcl = 0;
testEnd = 0;

for ( k = 0; k < (nbLignes+1); k++ ) {
    ligneTraitee = 0;
    /*--------------------------------*/
    /* Acquisition de la k-ieme ligne */
    /*--------------------------------*/
    l = 0;
    check = 0;
    c = getc(fScript);
    while ( ( ( c != ';' ) || ( check%2 != 0 ) ) && ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) {
          ligne[l] = c;
          c = getc(fScript);
          if ( c == '"' ) check++;
          l++;
    }
    while ( l < 5000 ) {
          ligne[l] = '\0';
          l++;
    }
    while ( ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) c = getc(fScript);
    
    if ( ( ligne[0] == '\n' ) || ( ligne[0] == '\r' ) || ( ligne[0] == EOF ) ) ligneTraitee = 1;
    
    /*----------------------------------------------------------------------------------------*/
    /*                     Dtection des erreurs de syntaxe dans la ligne                     */
    /*----------------------------------------------------------------------------------------*/
        
    /* Recherche des cas o on ouvre un guillement sans le fermer (erreur 10) */
    test = 0;
    for ( l = 0; l < strlen(ligne); l++ ) {
        if ( ligne[l] == '"' ) {
             test = 1 - test;
        }
    }    
    if ( test == 1 ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : un guillemet n'a pas t referm.");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    /* Recherche des cas o on ouvre une parenthses sans la fermer (erreur 11) et o on ne met pas d'espace avant ou aprs la parenthse (respectivement erreurs 12 et 13) */
    test = 0;
    for ( l = 0; l < strlen(ligne); l++ ) {
        if ( ligne[l] == '(' ) {
             if ( l > 0 ) {
                  if ( ligne[l-1] != ' ' ) {
                       fLog = fopen("DbTempTES3", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace avant.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             var = strlen(ligne)-1;
             if ( l < var ) {
                  if ( isspace(ligne[l+1]) == 0 ) {
                       fLog = fopen("DbTempTES3", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace aprs.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             test++;
        }
        if ( ligne[l] == ')' ) {
             if ( l > 0 ) {
                  if ( ligne[l-1] != ' ' ) {
                       fLog = fopen("DbTempTES3", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace avant.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             var = strlen(ligne)-1;
             if ( l < var ) {
                  if ( isspace(ligne[l+1]) == 0 ) {
                       fLog = fopen("DbTempTES3", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace aprs.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             test--;
        }
    }
    
    if ( test > 0 ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : ");
         int2str(&(cInt[0]), test);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " parenthse");
         if ( test > 1 ) strcat(err.messageErr, "s n'ont pas t refermes.");
         else strcat(err.messageErr, " n'a pas t referme.");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ligneTraitee == 0 ) {
         var = 0;
         for ( l = 0; l < strlen(ligne); l++ ) {
             if ( isspace(ligne[l]) == 0 ) var = 1;
         }
         if ( var == 0 ) ligneTraitee = 1;
    }
    
    
    synDetectBadTab(ligne, k);
   
    
/* Fonctions intervenant avant les blocs Begin/End */
    /* Nom du script */
    varScn = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncID("Begin", 99, ligne, &ligneTraitee, k);
    if ( ( varScn == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 1 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez dclar plusieurs fois le nom du script !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    if ( ( varScn == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 0 ) ) nomScript = 1;
    
    
    /* Dclaration des variables */
    varDcl = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncID("Short", 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Float", 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Long", 2, ligne, &ligneTraitee, k);
    if ( ( varDcl == 0 ) && ( ligneTraitee == 1 ) && ( declarations != 0 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez dclar des variables aprs des lignes de code !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }

    var = ligneTraitee;

/* Fonctions systme (ncessaires ou trs frquentes) */
    cEnd = ligneTraitee;
    if ( ligneTraitee == 0 ) synDetectSetTo(ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) synDetectTEST("If", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) synDetectTEST("ElseIf", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) synDetectTEST("While", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFonctionSeule("Else", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("Endif", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EndWhile", ligne, &ligneTraitee, k);
    m = ligneTraitee;
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("End", 19, 99, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("End", ligne, &ligneTraitee, k);
    if ( ( m == 0 ) && ( ligneTraitee == 1 ) ) {
         testEnd = 1;
         cEnd = 1;
    }
    if ( ligneTraitee == 0 ) strFonctionSeule("Return", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectMessageBox(ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) synDetectPlaceAtPC(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectFadeTo(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectChoice(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectModRegion(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPosition(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPositionCell(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectSay(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPlaySoundVP(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPlaySound3DVP(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPlayLoopSound3DVP(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectModPCFacRep(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectSetPCFacRep(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectLoopGroup(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectJournal(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIActivate(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIEscort(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIEscortCell(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIFollow(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIFollowCell(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAITravel(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectAIWander(ligne, &ligneTraitee, k);

    if ( ligneTraitee == 0 ) strFonctionSeule("EnableInventoryMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableMagicMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableMapMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableStatsMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableBirthMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableClassMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableNameMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableRaceMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableStatReviewMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableLevelUp", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableRest", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerControls", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerFighting", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerJumping", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerLooking", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerMagic", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerViewSwitch", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableVanityMode", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerControls", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerFighting", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerJumping", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerLooking", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerMagic", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerViewSwitch", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisableVanityMode", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableTeleporting", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisableTeleporting", ligne, &ligneTraitee, k);
    
    m = ligneTraitee;
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableLevitation", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisableLevitation", ligne, &ligneTraitee, k);
    if ( ( m == 0 ) && ( ligneTraitee == 1 ) && ( trib == 0 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : fonction Tribunal-dpendante !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }

    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Enable", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Disable", ligne, &ligneTraitee, k, 19);
    
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("Activate", 19, 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Activate", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("AddItem", 10, 11, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDID_choiceApp("AddSoulGem", ligne, 10, 46, 38, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("AddSpell", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("AddTopic", 15, 50, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDID_choiceApp("Cast", ligne, 19, 20, 19, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncBroken("CellUpdate", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("CenterOnCell", 95, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Coc", 95, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncShortShort_choiceApp("CenterOnExterior", 19, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncShortShort_choiceApp("Coe", 19, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("ChangeWeather", 19, 90, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ClearForceSneak", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ClearInfoActor", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule("DontSaveObject", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("DropSoulGem", 10, 38, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("Drop", 10, 11, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncShortShort_choiceApp("Face", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloat_choiceApp("FadeIn", 19, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloat_choiceApp("FadeOut", 19, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("Fall", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("FixMe", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceGreeting", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceSneak", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("GoodBye", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule("GoToJail", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloat_choiceApp("HurtStandingActor", 19, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("Lock", 41, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("LowerRank", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule("MenuTest", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("ModFactionReaction", ligne, 91, 91, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("Move", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("MoveWorld", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFonctionSeule("PayFineThief", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PayFine", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("PCClearExpelled", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCClearExpelled", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("PCExpell", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCExpell", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCForce3rdPerson", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCForce1stPerson", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("PCJoinFaction", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCJoinFaction", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("PCLowerRank", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCLowerRank", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("PCRaiseRank", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PCRaiseRank", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("PlayBink", 19, 92, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("PlayGroup", ligne, 15, 62, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("PlaySound", 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("PlaySound3D", 19, 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("PlayLoopSound3D", 19, 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("RaiseRank", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncValShortApp("RemoveEffects", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("RemoveItem", 10, 11, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("RemoveSoulGem", 10, 46, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("RemoveSpell", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("RemoveSpellEffects", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Resurrect", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("Rotate", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("RotateWorld", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("SetAngle", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SetAtStart", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("SetFactionReaction", ligne, 91, 91, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetJournalIndex", 19, 51, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("SetPos", 19, ligne, &ligneTraitee, k, trib);
    if ( ligneTraitee == 0 ) strFoncID("ShowMap", 95, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowRestMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SkipAnim", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncIDApp("StartCombat", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StartScript", 96, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("StopCombat", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncID("StopScript", 96, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StopSound", 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StreamMusic", 92, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Unlock", ligne, &ligneTraitee, k, 41);
    if ( ligneTraitee == 0 ) strFonctionSeule("WakeUpPC", ligne, &ligneTraitee, k);
        
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAcrobatics", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAgility", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAlarm", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAlchemy", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAlteration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModArmorBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModArmorer", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAthletics", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAttackBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModAxe", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModBlindness", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModBlock", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModBluntWeapon", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModCastPenalty", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModChameleon", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModConjuration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModCurrentFatigue", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModCurrentHealth", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModCurrentMagicka", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModDefendBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModDestruction", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModDisposition", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModEnchant", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModEndurance", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModFatigue", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModFight", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModFlee", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModFlying", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModHandToHand", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModHealth", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModHeavyArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModHello", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModIllusion", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModIntelligence", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModInvisible", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModInvisibile", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModLightArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModLongBlade", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModLuck", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModMarksman", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModMediumArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModMagicka", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModMercantile", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModMysticism", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModParalysis", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("ModPCCrimeLevel", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("ModPCVisionBonus", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModPersonality", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModReputation", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistBlight", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistCorprus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistDisease", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistFire", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistFrost", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistMagicka", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistNormalWeapons", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistParalysis", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistPoison", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModResistShock", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModRestoration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSecurity", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModShortBlade", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSilence", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSneak", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSpear", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSpeechCraft", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSpeed", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModStrength", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSuperJump", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModSwimSpeed", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModUnarmored", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModWaterBreathing", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModWaterWalking", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModWillPower", 15, ligne, &ligneTraitee, k, trib, blood);
        
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAcrobatics", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAgility", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAlarm", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAlchemy", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAlteration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetArmorBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetArmorer", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAthletics", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAttackBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetAxe", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetBlindness", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetBlock", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetBluntWeapon", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetCastPenalty", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetChameleon", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetConjuration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetDefendBonus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetDestruction", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetDisposition", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetEnchant", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetEndurance", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetFatigue", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetFight", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetFlee", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetFlying", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetHandToHand", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetHealth", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetHeavyArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetHello", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetIllusion", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetIntelligence", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetInvisible", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetInvisibile", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetLevel", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetLightArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetLongBlade", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetLuck", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetMarksman", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetMediumArmor", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetMagicka", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetMercantile", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetMysticism", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetParalysis", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("SetPCCrimeLevel", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("SetPCVisionBonus", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetPersonality", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetReputation", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistBlight", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistCorprus", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistDisease", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistFire", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistFrost", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistMagicka", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistNormalWeapons", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistParalysis", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistPoison", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetResistShock", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetRestoration", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSecurity", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetShortBlade", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSilence", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSneak", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSpear", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSpeechCraft", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSpeed", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetStrength", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSuperJump", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetSwimSpeed", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetUnarmored", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetWaterBreathing", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetWaterWalking", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetWillPower", 15, ligne, &ligneTraitee, k, trib, blood);
    
    
    // Tribunal    
    m = ligneTraitee;
    
    if ( ligneTraitee == 0 ) synDetectPlaceItem(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPlaceItemCell(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("AddToLevCreature", ligne, 48, 46, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("AddToLevItem", ligne, 49, 19, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ClearForceJump", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ClearForceMoveJump", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ClearForceRun", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisableLevitation", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableLevitation", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("Equip", 15, 16, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("ExplodeSpell", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceJump", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceMoveJump", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceRun", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncValFloat_choiceApp("HurtCollidingActor", 19, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("RemoveFromLevCreature", ligne, 48, 46, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("RemoveFromLevItem", ligne, 49, 19, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetDelete", 19, ligne, &ligneTraitee, k);
    
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("ModScale", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("ModWaterLevel", ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStatApp("SetScale", 15, ligne, &ligneTraitee, k, trib, blood);
    if ( ligneTraitee == 0 ) strFoncValShortStat("SetWaterLevel", ligne, &ligneTraitee, k, trib, blood);
    
    if ( ( m == 0 ) && ( ligneTraitee == 1 ) && ( trib == 0 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : fonction Tribunal-dpendante !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    
    // Bloodmoon
    m = ligneTraitee;
    
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("BecomeWerewolf", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) synDetectPlaceAtMe(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("SetWerewolfAcrobatics", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("TurnMoonRed", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("TurnMoonWhite", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("UndoWerewolf", ligne, &ligneTraitee, k, 15);
        
    if ( ( m == 0 ) && ( ligneTraitee == 1 ) && ( blood == 0 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : fonction Bloodmoon-dpendante !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }

    
    
    if ( ( cEnd == 0 ) && ( ligneTraitee == 1 ) && ( testEnd == 1 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez entr des lignes de code aprs la balise \"End\" !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ( var == 0 ) && ( ligneTraitee == 1 ) ) declarations = 1;
    
    if ( ( var == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 0 ) ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez entr des lignes de code avant l'en-tte \"Begin NOM\" !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ligneTraitee == 0 ) {
         fLog = fopen("DbTempTES3", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : impossible de dtecter la syntaxe !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
}

fclose(fScript);

}
